package DataFile01;

use Exporter;
@ISA = (Exporter);
@EXPORT = qw(return_convt return_blosum62);
    
sub return_convt{
    my %convt = (
        'C'=>['C'],
        'S'=>['S'],
        'T'=>['T'],
        'P'=>['P'],
        'A'=>['A'],
        'G'=>['G'],
        'N'=>['N'],
        'D'=>['D'],
        'E'=>['E'],
        'Q'=>['Q'],
        'H'=>['H'],
        'R'=>['R'],
        'K'=>['K'],
        'M'=>['M'],
        'I'=>['I','V'],
        'L'=>['L'],
        'V'=>['I','V'],
        'F'=>['F','Y'],
        'Y'=>['F','Y'],
        'W'=>['W']
    );
    
    return \%convt;
}

sub return_blosum62{
    my @blosum62 = ( #BLOSUM62
        [9,-1,-1,-3,0,-3,-3,-3,-4,-3,-3,-3,-3,-1,-1,-1,-1,-2,-2,-2], #C
        [-1,4,1,-1,1,0,1,0,0,0,-1,-1,0,-1,-2,-2,-2,-2,-2,-3],  #S
        [-1,1,4,1,-1,1,0,1,0,0,0,-1,0,-1,-2,-2,-2,-2,-2,-3],  #T
        [-3,-1,1,7,-1,-2,-1,-1,-1,-1,-2,-2,-1,-2,-3,-3,-2,-4,-3,-4],   #P
        [0,1,-1,-1,4,0,-1,-2,-1,-1,-2,-1,-1,-1,-1,-1,-2,-2,-2,-3],    #A
        [-3,0,1,-2,0,6,-2,-1,-2,-2,-2,-2,-2,-3,-4,-4,0,-3,-3,-2],  #G
        [-3,1,0,-2,-2,0,6,1,0,0,-1,0,0,-2,-3,-3,-3,-3,-2,-4],  #N
        [-3,0,1,-1,-2,-1,1,6,2,0,-1,-2,-1,-3,-3,-4,-3,-3,-3,-4], #D
        [-4,0,0,-1,-1,-2,0,2,5,2,0,0,1,-2,-3,-3,-3,-3,-2,-3], #E
        [-3,0,0,-1,-1,-2,0,0,2,5,0,1,1,0,-3,-2,-2,-3,-1,-2],    #Q
        [-3,-1,0,-2,-2,-2,1,1,0,0,8,0,-1,-2,-3,-3,-2,-1,2,-2],    #H
        [-3,-1,-1,-2,-1,-2,0,-2,0,1,0,5,2,-1,-3,-2,-3,-3,-2,-3],    #R
        [-3,0,0,-1,-1,-2,0,-1,1,1,-1,2,5,-1,-3,-2,-3,-3,-2,-3], #K
        [-1,-1,-1,-2,-1,-3,-2,-3,-2,0,-2,-1,-1,5,1,2,-2,0,-1,-1],  #M
        [-1,-2,-2,-3,-1,-4,-3,-3,-3,-3,-3,-3,-3,1,4,2,1,0,-1,-3], #I
        [-1,-2,-2,-3,-1,-4,-3,-4,-3,-2,-3,-2,-2,2,2,4,3,0,-1,-2],   #L
        [-1,-2,-2,-2,0,-3,-3,-3,-2,-2,-3,-3,-2,1,3,1,4,-1,-1,-3],    #V
        [-2,-2,-2,-4,-2,-3,-3,-3,-3,-3,-1,-3,-3,0,0,0,-1,6,3,1], #F
        [-2,-2,-2,-3,-2,-3,-2,-3,-2,-1,2,-2,-2,-1,-1,-1,-1,3,7,2],   #Y
        [-2,-3,-3,-4,-3,-2,-4,-4,-3,-2,-2,-3,-3,-1,-3,-2,-3,1,2,11]  #W
    );

    return \@blosum62;
}

return 1;

__END__

    'C'=>['C'],
    'S'=>['S'],
    'T'=>['T'],
    'P'=>['P'],
    'A'=>['A'],
    'G'=>['G'],
    'N'=>['N'],
    'D'=>['D','E'],
    'E'=>['D','E','Q'],
    'Q'=>['E','Q'],
    'H'=>['H','Y'],
    'R'=>['R','K'],
    'K'=>['R','K'],
    'M'=>['M','L'],
    'I'=>['I','L','V'],
    'L'=>['M','I','L'],
    'V'=>['I','V'],
    'F'=>['F','Y'],
    'Y'=>['F','Y','W'],
    'W'=>['Y','W']
        
    'C'=>['C'],
    'S'=>['S','T','A','N'],
    'T'=>['S','T'],
    'P'=>['P'],
    'A'=>['S','A'],
    'G'=>['G'],
    'N'=>['N','D','H'],
    'D'=>['N','D','E'],
    'E'=>['D','E','Q','K'],
    'Q'=>['E','Q','R','K'],
    'H'=>['N','H','Y'],
    'R'=>['Q','R','K'],
    'K'=>['E','Q','R','K'],
    'M'=>['M','I','L','V'],
    'I'=>['M','I','L','V'],
    'L'=>['M','I','L','V'],
    'V'=>['M','I','L','V'],
    'F'=>['F','Y','W'],
    'Y'=>['F','Y','W'],
    'W'=>['F','Y','W']