package FragExtend01;

use Exporter;
@ISA = (Exporter);
@EXPORT = qw(frag_extend);

use DataFile01;
    
sub frag_extend{

    my ($d_id,$d_seq,$d_pos,$q_id,$q_seq,$q_pos) = @_;
    my $d_len = length($d_seq);
    my $q_len = length($q_seq);
    my $d_ptr = $d_pos-2;
    my $q_ptr = $q_pos;
    
    # Lower limit score
    my $lowest = 1+log(($q_len+1)*($d_len+1))/log(2)*3; # 1+(log(($q_len+1)*($d_len+1)))*2;#1+log(($q_len+1)*($d_len+1))/log(2)*3;
    #print "lowest = $lowest\n";
    
    # Convert sequences into arrays
    my @q_aas = split(//,$q_seq);
    my @d_aas = split(//,$d_seq);
    
    # Hash for conversion of amino acid to number
    my $all_aa_str = "CSTPAGNDEQHRKMILVFYW";
    my @all_aas = split(//,$all_aa_str);
    my %an_cnvd;
    my $num = 0;
    foreach (@all_aas){
        $an_cnvd{$_} = $num;
        $num++;
    }
    
    # Convert amino acid alphapet to number
    $_ = $an_cnvd{$_} foreach (@q_aas);
    $_ = $an_cnvd{$_} foreach (@d_aas);
    
    # Import BLOSUM62 matrix
    my $ref_score_matrix = &return_blosum62;
    my @score_matrix = @{$ref_score_matrix};
    
    #print "dptr=$d_ptr,dlen=$d_len;qptr=$q_ptr,qlen=$q_len\n";

    my $score= 0;
    my $tmp_score = 0;
    while($d_ptr<$d_len && $q_ptr<$q_len){
        $tmp_score = $score;
        return 'SAVE' if ($score > $lowest);
        last if ($score_matrix[$d_aas[$d_ptr]][$q_aas[$q_ptr]]<0); #####
        $score += $score_matrix[$d_aas[$d_ptr]][$q_aas[$q_ptr]];
        
        $d_ptr++;
        $q_ptr++;
    }
    #return 'SAVE' if ($score > $lowest);
    $d_ptr = $d_pos-2;
    $q_ptr = $q_pos;
    while($d_ptr>0 && $q_ptr>0){
        $tmp_score = $score;
        return 'SAVE' if ($score > $lowest);
        last if ($score_matrix[$d_aas[$d_ptr]][$q_aas[$q_ptr]]<0); #####
        $score += $score_matrix[$d_aas[$d_ptr]][$q_aas[$q_ptr]];

        $d_ptr--;
        $q_ptr--;
    }

    if ($score > $lowest){
        #print "score = $score\n";
        return 'SAVE';
    }else{
        return 'NEXT';
    }

}

return 1;

__END__

    for(0..2){
        print substr($d_seq,$d_pos+$_-2,1);
    }
    print "\n";
    for(0..2){
        print substr($q_seq,$q_pos+$_,1);
    }
    print "\n\n";